#!/usr/bin/env python

import portopt

var = [
[0.0672407259,0.0220657435,0.0318098601,0.000925332],
[0.0220657435,0.0092870048,0.0074273922,-0.0069140932],
[0.0318098601,0.0074273922,0.0209531443,0.0153389225],
[0.000925332,-0.0069140932,0.0153389225,0.0456093631]]
means = [1.9707776793,2.434023944,3.5785531334,4.6465545908]
alpha = 20
nvar = len(means)

results = portopt.solveport(var,means,alpha)
cost = results[0]
shares = results[1]
errorcode = results[2]

opt_mean = 0
opt_var = 0

if errorcode == 1:
  print "An error happened with the data feed to the optimisation routing - either different number of vbariables of covariance matrix is not simmetric"
  exit(1)
if errorcode == 2:
  print "The problem has no solutions"
  exit(1) 
  
for i in xrange(nvar): 
  opt_mean += shares[i] * means[i]
  for j in xrange(nvar): 
    opt_var += shares[i]*shares[j]* var[i][j]

print "Number of variables: "+str(nvar)    
print "Optimal portfolio variance: "+str(opt_var)
print "Optimal portfolio mean: "+str(opt_mean)
print "Cost of the optimisation function: "+str(cost)
print "Assets chares: "
for i in xrange(nvar):
  print str(i)+": "+str(shares[i])